<?php
class ContactController extends Controller { // classe de contrôleur pour l'inscription au site

	public function displayValid() { // la fonction d'affichage du formulaire
		$this->view->display();
	}

	public function displayForm() { // la fonction d'affichage du formulaire
		session_start();
		
		if(isset($_SESSION['contactErrCode'])) { // si message d'erreur
			$errCode = $_SESSION['contactErrCode'];
			if($errCode == 2) { // on détermine le message
				$errMsg = '<h3>Veuillez indiquer votre nom !</h3>';
			} 
			elseif($errCode == 3) { 
				$errMsg = '<h3>Veuillez indiquer votre prénom !</h3>';
			} 
			elseif($errCode == 4) {
				$errMsg = '<h3>Veuillez indiquer une adresse mail valide !</h3>';
			}
			elseif($errCode == 5) { 
				$errMsg = '<h3>Veuillez indiquer votre message !</h3>';
			} 
            else{
                $errMsg = "<h3>Exception non gérée.</h3>";
            }
			
			unset($_SESSION['contactErrCode']); // on retire la variable de session
			
            $this->view->errMsg = $errMsg;
		}
		
		$this->view->display();
	}

	public function send() { // vérifie les données de contact
		if(!isset($_POST['nom']) || !isset($_POST['prenom']) || !isset($_POST['email']) || !isset($_POST['message'])) { // si l'une des données manque, erreur
			//appeler une fonction d'erreur
			echo "<h1>Erreur : variables absentes</h1>";
			die();
		}
		$data = $_POST;
		
		if($data['nom'] == "") {
			session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
			$_SESSION["contactErrCode"] = 2; // on stocke le code d'erreur
			header('Location:../contact'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne)
		}
		if($data['prenom'] == "") {
			session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
			$_SESSION["contactErrCode"] = 3; // on stocke le code d'erreur
			header('Location:../contact'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne)
		}
		if(!preg_match("#^[a-z0-9._-]+(@|%40)[a-z0-9._-]{2,}\.[a-z]{2,4}$#", $data['email'])) {
			session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
			$_SESSION["contactErrCode"] = 4; // on stocke le code d'erreur
			header('Location:../contact'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne)
		}
		if($data['message'] == null) {
			session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
			$_SESSION["contactErrCode"] = 5; // on stocke le code d'erreur
			header('Location:../contact'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne)
		}
		
		$sender = $data['prenom'];
		if($data['pseudo'] != "") $sender .= " '".$data['pseudo']."'";
		$sender .= " ".$data['nom'];
		
		$header = "From: \"".$sender."\"<".$data['email'].">\n";
		$header.= "Reply-to: \"".$sender."\"<".$data['email'].">\n";
		$header.= "MIME-Version: 1.0\n";
		
		$success = mail(
			"vbochet@gmail.com", // adresse email du destinataire
			"Message envoyé via Classements Ludiques", // objet du mail
			htmlspecialchars($data['message']), // message du mail
			$header);// on réalise l'inscription à l'aide d'une méthode de la classe Register
		if ($success == 1) {
			header('Location:valid'); // on redirige vers la  page OK
		} 
		else {
			echo "<h1>Erreur : l'envoi du mail a échoué</h1>";
		}
	}
	
}
